#ifndef _RESULT_VALIDATOR_HPP
#define _RESULT_VALIDATOR_HPP

// System includes
#include <cstring>
#include <vector>

// Local includes
#include "validator_client.hpp"

using std::string;
using std::vector;

namespace prc {

/**
 * The ResultValidator class is responsible for validating results.
 * It has three methods, each of which performs a different type of validation.
 * The three types of validation include:
 *	1. Validating a single result.
 *	2. Selecting a canonical result from a set of results.
 *	3. Validating a spot-check.
 */
class ResultValidator {
	public:
		bool validateSingleResult(Result&);
		string selectCanonicalResult(vector<Result>&);
		bool validateSpotCheck(SpotCheck&);
};

} // end namespace prc

#endif // _RESULT_VALIDATOR_HPP
