// System includes
#include <cstdlib>
#include <cstring>
#include <iostream>

// Local includes
#include "validator_client.hpp"

using std::cout;
using std::endl;
using std::string;
using namespace prc;

int main(int argc, char** argv) {
	// If no results found, wait 30 seconds before trying again.
	static const int RETRY_DELAY = 30;

	cout << "Starting Example Result Validator." << endl;

	// If specified via the command line, set the server address.
	if (argc == 2)
		ValidatorClient::instance()->setServerAddress(argv[1]);

	// Sit in a loop, validating results.
	// If the server did not have any results, wait for RETRY_DELAY seconds, then check again.
	while (true) {
		try {
			ValidatorClient::instance()->validateNextResult();
		} catch (string error) {
			// There were no results to validate.
			cout << "Retrying in " << RETRY_DELAY << " seconds." << endl;
			sleep(RETRY_DELAY);
		}
	}

	return EXIT_SUCCESS;
}
