#ifndef _GENERATOR_HPP
#define _GENERATOR_HPP

// System includes
#include <cstdlib>
#include <vector>

// Local includes
#include "common/common.hpp"

using std::vector;

namespace prc {

class WorkUnitGenerator {
	private:
		static const double DEFAULT_EXPIRATION_TIME = 900;	// The number of seconds before each 
									// work unit expires (1 day is the 
									// default).
		static const int DEFAULT_PRIORITY = 0;			// The priority of each work unit.
		static const int DEFAULT_POINTS = 1;			// The point value of each work unit.
		static const int RANGE_LENGTH = 1000000;		// Length of each range.
		int nextWorkUnitID;					// The ID of the next work unit to be generated.
									// Used in the addWorkUnit RPC.
		int nextStartRange;					// Start point of next range.
		int nextEndRange;					// End point of next range.
		//static int byteVectorToInt(const vector<byte>&);
		//static vector<byte> intToByteVector(int);
		void recoverState();
		vector<byte>* generateWorkUnit();
	public:
		WorkUnitGenerator();
		size_t generateAndSend(int);
};

} // end namespace prc

#endif // _GENERATOR_HPP
