#ifndef _GENERATOR_HPP
#define _GENERATOR_HPP

// System includes
#include <cstdlib>
#include <vector>

// Local includes
#include "common/common.hpp"

using std::vector;

namespace prc {

/**
 * The WorkUnitGenerator contains the project-specific 
 * code to generate work units.  It uses the WorkGeneratorClient
 * to send them to the project server.
 * @author James Baldassari
 */
class WorkUnitGenerator {
	private:
		static const double DEFAULT_EXPIRATION_TIME = 900;	// The number of seconds before each 
									// work unit expires (1 day is the 
									// default).
		static const int DEFAULT_PRIORITY = 0;			// The priority of each work unit.
		static const int DEFAULT_POINTS = 1;			// The point value of each work unit.

		void recoverState();
		vector<byte>* generateWorkUnit();
	public:
		WorkUnitGenerator();
		size_t generateAndSend(int);
};

} // end namespace prc

#endif // _GENERATOR_HPP
