package edu.wpi.prc.client.test;

import java.io.IOException;
import java.util.Vector;

import org.apache.xmlrpc.XmlRpcException;

import edu.wpi.prc.client.PRCClient;
import edu.wpi.prc.project.MissingConfigurationFileException;
import edu.wpi.prc.task.TaskFactory;
import edu.wpi.prc.task.WorkUnit;
import junit.framework.TestCase;

/**
 * Tests the Client.
 * @author James Baldassari
 */
public class PRCClientTest extends TestCase {
	public void testClient() {
		PRCClient client = null;
		try {
			client = PRCClient.instance();
		} catch (MissingConfigurationFileException e) {
			assertTrue(false);
		}
		
		try {
			Vector<String> v = new Vector<String>();
			v.add(new String("jdb"));
			Object result = client.getXmlRpcPRCServerClient().execute("server.getWorkUnit", v);
			WorkUnit wu = null;
			try {
				wu = TaskFactory.createWorkUnit();
				Vector workUnitVector = (Vector)result;
				wu.setTaskID((String)workUnitVector.elementAt(0));
				wu.setData((byte[])workUnitVector.elementAt(1));
				
				System.out.println("Received a WorkUnit:");
				System.out.println("\tTaskID: " + wu.getTaskID());
				System.out.print("\tData: ");
				for (byte datum : wu.getData()) {
					System.out.print(datum + " ");
				}
				System.out.println();
			} catch (ClassCastException e) {
				System.out.println("Server returned an Exception: " + result);
				System.out.println(e.getCause());
				e.getCause().printStackTrace();
				wu = null;
				assertTrue(false);
			}
		} catch (XmlRpcException e) {
			System.out.println(e);
			assertTrue(false);
		} catch (IOException e) {
			System.out.println(e);
			assertTrue(false);
		}
		assertTrue(true);
		
		// Kill the server
		try {
			@SuppressWarnings("unused") Object result = client.getXmlRpcPRCServerClient().execute("server.shutdown", new Vector());
		} catch (XmlRpcException e) {
			System.out.println(e);
		} catch (IOException e) {
			System.out.println(e);
		}
	}
}