package edu.wpi.prc.example;

import edu.wpi.prc.persistence.DatabaseType;
import edu.wpi.prc.persistence.HibernateController;
import edu.wpi.prc.project.MissingConfigurationFileException;
import edu.wpi.prc.project.Project;

/**
 * Saves the example project to the database.
 * @author James Baldassari
 */
public class ExampleProject {

	public static void main(String[] args) {
		try {
			HibernateController.instance().initialize();
		} catch (MissingConfigurationFileException e) {
			System.out.println(e);
			System.err.println(e);
			System.exit(1);
		}
		HibernateController.instance().exportSchema();	// Reset the database.
		
		// Save the project configuration.
		Project p = Project.instance();
		p.setName("Example Project");
		p.setPassword("wpiprc");
		p.setDbType(DatabaseType.MySQL);
		p.setDbURI("mysql.wpi.edu/jdbprcthesis");
		p.setDbUserName("jdbprc");
		p.setDbPassword("zEPyLS");
		p.setMinNumResults(1);
		//p.setMinNumSpotChecks(3);
		//p.setSpotCheckProbability(0.05f);
		p.setServerURI("cstag04.cs.wpi.edu:2080");
		p.setScienceApp("run_sci_app.sh");
		p.setScienceAppPort(2082);
		//p.setTransitionerURI("192.168.1.100:2083");		// For testing remote transitioner.
		p.saveOrUpdate();
		
		HibernateController.instance().shutdown();
		System.out.println("Example Project Saved.");
	}
}
