package edu.wpi.prc.persistence;

/**
 * Indicates the type of database used.
 * @author James Baldassari
 */
public enum DatabaseType {
	HSQLDB("HSQLDB"),
	MySQL("MySQL"),
	PostgreSQL("PostgreSQL"),
	Oracle("Oracle"),
	MSSQLServer("SQLServer");
	
	private final String dbString;
	
	DatabaseType(String dbString) {
		this.dbString = dbString;
	}
	
	public String toString() {
		return dbString;
	}
	
	public String getConfigurationFileName() {
		return "hibernate." + dbString.toLowerCase() + ".cfg.xml";
	}
}
