/**
 * 
 */
package edu.wpi.prc.server;

/**
 * Indicates an invalid work unit or result was requested.
 * @author James Baldassari
 */
public class InvalidTaskException extends Exception {
	private static final long serialVersionUID = 1L;
	private String message = "InvalidTaskException";
	
	/**
	 * Default constructor.
	 */
	public InvalidTaskException() {
		
	}
	
	/**
	 * Constructor specifying an error message.
	 * @param message The error message to set.
	 */
	public InvalidTaskException(String message) {
		this.message += ": " + message;
	}
	
	/**
	 * @return Returns the error message for this Exception.
	 */
	public String toString() {
		return message;
	}
}
