package edu.wpi.prc.server;

/**
 * Indicates that a user could not be found in the database.
 * @author James Baldassari
 */
public class InvalidUserException extends Exception {
	private static final long serialVersionUID = 1L;
	private String message = "InvalidUserException";
	
	/**
	 * Default constructor.
	 */
	public InvalidUserException() {
		
	}
	
	/**
	 * Constructor specifying an error message.
	 * @param message The error message.
	 */
	public InvalidUserException(String message) {
		this.message += ": " + message;
	}
	
	/**
	 * Returns the error message for this Exception.
	 */
	public String toString() {
		return message;
	}
}
