package edu.wpi.prc.server.test;

import java.util.Date;

import edu.wpi.prc.persistence.HibernateController;
import edu.wpi.prc.project.Project;
import edu.wpi.prc.server.PRCServer;
import edu.wpi.prc.task.TaskFactory;
import edu.wpi.prc.task.TaskState;
import edu.wpi.prc.task.WorkUnit;
import edu.wpi.prc.user.Volunteer;
import junit.framework.TestCase;

public class PRCServerTest extends TestCase {

	public PRCServerTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		super.setUp();
		
		HibernateController.instance().initializeForUnitTests();
		
		// Configure the project.
		Project p = Project.createProject();
		p.setServerURI("cstag04.cs.wpi.edu:2080");
		p.saveOrUpdate();
		
		// Add user.
		Volunteer user = new Volunteer();
		user.setUserID("jdb");
		user.setEMailAddress("jdb@cs.wpi.edu");
		user.setJoinDate(new Date());
		user.save();
		
		// Add WorkUnit.
		WorkUnit wu = TaskFactory.createWorkUnit();
		wu.setData(new byte[] { 1, 2, 3, 4 });
		wu.setState(TaskState.Ingress);
		wu.assignUser(user);
		wu.save();
		
		HibernateController.instance().shutdown();
	}

	public void testServer() {		
		// Start the server.
		PRCServer.main(new String[0]);
		
		assertTrue(true);
	}
}
