package edu.wpi.prc.util.password;

/**
 * Erases the cleartext password typed by the user and replaces it with asterisks.
 * NOTE: This implementation inspired by http://java.sun.com/developer/technicalArticles/Security/pwordmask/.
 * @author James Baldassari
 */
public class PasswordEraserThread extends Thread {
	private volatile boolean isMasking = true;
	
	/**
	 * Constructor that takes a password prompt.
	 * @param prompt The password prompt to display.
	 */
	public PasswordEraserThread(String prompt) {
		System.out.print(prompt);
	}
	
	/**
	 * Begins replacing characters with asterisks.
	 */
	public void run() {
		setPriority(Thread.MAX_PRIORITY);
		while (isMasking == true) {
			System.out.print("\b ");
			try {
				sleep(1);
			} catch(InterruptedException e) {
				
			}
		}
		setPriority(Thread.MIN_PRIORITY);
	}
	
	/**
	 * Stops replacing characters with asterisks.
	 */
	public void stopMasking() {
		isMasking = false;
	}
}